Range Sum Query 2D - Immutable - Leetcode 304 - Python

Поделиться
HTML-код
  • Опубликовано: 17 ноя 2024

Комментарии • 39

  • @blossombabalola1234
    @blossombabalola1234 2 года назад +27

    Thank you Neet. This concept is a bit difficult to explain but you did a good job!

  • @mohammedafzal4343
    @mohammedafzal4343 Год назад +7

    At first, it was a little tough to understand, but I watched this video multiple times. Now I fully understood the concept! thanks Neetcode!

  • @Mad7K
    @Mad7K 2 года назад +4

    To be honest at the start I thought I was completely off the mark, but that's exactly how I solved it, thanks for the video.

  • @kariuki6644
    @kariuki6644 2 года назад +5

    My first time hearing about prefix sum but this made it easier to understand

  • @SkyeTian
    @SkyeTian 2 года назад +3

    I understand why we are adding a top row since it would be out of bounds when we are calculating prefix sum for the first row (no "above"), but why are we also adding a left column?

  • @aishwaryaranghar3385
    @aishwaryaranghar3385 2 года назад +6

    Really liking the strategy of posting videos on the streak day!!

  • @dabobrotosarkar7266
    @dabobrotosarkar7266 2 года назад +3

    Hey Neet! You explain great! I love your videos. Can you make a video about Problem 307. Range Sum Query - Mutable?
    It uses Segment Trees to optimize the algorithm. Would love to see that!

  • @DK-ox7ze
    @DK-ox7ze Год назад

    What's the logic behind calculating prefix sum for each cell? What's the intuition behind the formula you used?

  • @jasdeepsinghgrover2470
    @jasdeepsinghgrover2470 2 года назад

    This can be generalized to all shapes with vertical or horizontal edges... Then we can apply inclusion exclusion principle

  • @hinatahyuga3038
    @hinatahyuga3038 2 года назад +1

    thank you so much sir, took me 3 hours to understand it

  • @krishnalath1266
    @krishnalath1266 2 года назад +1

    Thank You for such a wonderful explanation....

  • @spyboy0076
    @spyboy0076 2 года назад +9

    I don't know what will i do. I can't think of anything while solving these problems

    • @staffeng
      @staffeng 2 года назад +12

      I think the only way is to first solve enough problems by learning through videos like this in a systemic manner, like going from one topic to another, practicing them again from memory, and then attempting enough new problems on our own till we are able to solve most of the unseen mediums. This is going to take an insane amount of time but for those like us who are not naturally gifted at this, I think it's the only way.
      @NeetCode - can you create a video on how you got to a stage where you can solve unseen mediums or hards?

    • @gunahawk6893
      @gunahawk6893 2 года назад

      @@staffeng great 👏

  • @programmermainul6558
    @programmermainul6558 2 года назад

    It would be great video. I am jumping on this r8 now. Cheers!

  • @reapergrim5324
    @reapergrim5324 4 месяца назад

    Line 10 : above = matrix[i][j+1]
    How is this above it should be right ?

  • @ainazikmomunalieva3732
    @ainazikmomunalieva3732 2 года назад

    Thank you! You are a master at explaining!

  • @amosluesun585
    @amosluesun585 2 года назад

    this is fabulous, nice work

  • @ይኩነኒ
    @ይኩነኒ Год назад

    you're de besttttt....Thank youuuuu

  • @pulakammalathy6968
    @pulakammalathy6968 2 года назад

    cant we compute the prefix matrix in place of the given matrix ?

  • @rajsuriyang3427
    @rajsuriyang3427 2 года назад

    one-liner:
    The time limit is exceeding, Why?
    return sum([sum(self.matrix[i:row2+1][0][col1:col2+1]) for i in range(row1,row2+1)])
    Can you explain?

    • @sirmidor
      @sirmidor 2 года назад +1

      Because you're completely ignoring what the exercise asks: What you typed is not O(1) time complexity for getting a region's sum. Your matrix indexing is also less than optimal: You're already looping over range(row1, row2 + 1), so you would just take self.matrix[i] instead of unnecessarily doing self.matrix[i:row2+1][0] to get a row of the matrix.

  • @Nisha.......
    @Nisha....... 2 года назад

    Sir, will you please solve leetcode 174?

  • @firomsamt7642
    @firomsamt7642 10 месяцев назад

    mind blowing!👏

  • @monadastar9393
    @monadastar9393 2 года назад

    thank you so much

  • @mohithadiyal6083
    @mohithadiyal6083 2 года назад +1

    No doubt , great video as usual 😀

  • @b9944236
    @b9944236 Год назад

    Tanks a lot ~

  • @sahaiabhishek
    @sahaiabhishek 10 месяцев назад

    Excellent

  • @rahulkhatoliya6814
    @rahulkhatoliya6814 2 года назад

    crystal clear

  • @theghostwhowalk
    @theghostwhowalk 2 года назад

    Great video. Mind helping with similar video on Range sum mutable 308 which has update func. Would be great to understand Index tree implementations.

  • @vasujain1970
    @vasujain1970 2 года назад

    Interesting video.

  • @kirillzlobin7135
    @kirillzlobin7135 10 месяцев назад

    Amazing

  • @robertlemiesz7143
    @robertlemiesz7143 7 месяцев назад

    I would honestly never ask this in an interview. Kinda feels like you either have seen the problem and know the answer, or need to take significant amount of time deriving it. Tells you nothing about the candidate, except whether or not they do alot of leet code.

  • @VidyaBhandary
    @VidyaBhandary 2 года назад

    Awesome ....

  • @johnvick8861
    @johnvick8861 Год назад

    within a min i understood .

  • @krateskim4169
    @krateskim4169 2 года назад

    nice

  • @shambhavi6888
    @shambhavi6888 6 месяцев назад

    🥹

  • @onepiece1570
    @onepiece1570 2 года назад

    go